


def python(version)
    if !Dir.exist?(File.expand_path("~/.pyenv"))
        sh "git clone https://github.com/pyenv/pyenv.git ~/.pyenv"
    end
    if !File.exist?(File.expand_path("~/.pyenv/versions/#{version}/bin/python"))
        sh "~/.pyenv/bin/pyenv install #{version}"
    end
    
    File.expand_path("~/.pyenv/versions/#{version}/bin/python")
end


namespace :app do

    task :env do
        if !File.exist?("app/.env")
            Dir.chdir("app") do
                version = File.read(".python-version").strip
                sh "#{python(version)} -m venv .env"
                sh ".env/bin/pip install --upgrade pip"
                sh ".env/bin/pip install wheel setuptools"
                sh ".env/bin/pip install -r requirements.txt"
            end
        end
    end

    task :settingsini => :env do
        if !File.exist?("settings.ini")
            if !File.exist?("../settings.ini")
                sh "app/.env/bin/fab pullsettings"
            end
        end
    end

    task :setup => [
        :env,
        :settingsini,
    ]

    task :run => :setup do
        sh "app/.env/bin/python app/sync.py --directory=../Documents"
    end
end

namespace :web do
    task :run => "app:setup" do
        Dir.chdir("app") do
            sh ".env/bin/hypercorn server"
        end
    end
end



task :run => [
    "app:run"
]
